#ifndef ENGINE_H_
#define ENGINE_H_

#include <string>
#include <SDL/SDL_opengl.h>

#include "SpriteConfig.h"
#include "Renderer.h"

class Engine {
public:
    static Engine& Get() {
        static Engine engine;
        return engine;
    }

    void Load() {
        m_sprite_config.reset(new SpriteConfig::SpriteConfig());
        m_renderer.reset(new Renderer::Renderer());
    }

    SpriteConfigPtr SpriteConfig() {
        return m_sprite_config;
    }

    RendererPtr Renderer() {
        return m_renderer;
    }

private:
    SpriteConfigPtr m_sprite_config;
    RendererPtr m_renderer;

};

#endif /* ENGINE_H_ */
